import {createContext} from 'preact';


class Session {
    static instance=null;
    observers = [];
    static getInstance(){
        if(this.instance==null)
            this.instance = new Session();
        return this.instance;
    }
    constructor(){
        console.log("new Instance of Session manager created");
        this.state={token:null,expiry:null,name:null}
    }
    observe(o){
        this.observers.push(o);
    }
    get Context(){
        return createContext(this);
    }
    setState(updated){
        this.state = {...this.state,...updated}
        this.observers.map(o=>o.forceUpdate());
        console.log(this.state);
    }
    Login(username, password) {
        if (username == "admin" && password == "admin") 
          { this.setState({token:"TEST",expiry: new Date(Date.now() + 60000*60),name:username});
          return true;
        }
        return false;
      }
    Logout = () => this.setState({token:null,expiry:null,name:null});
    get isAuthenticated(){
        return this.state.token!=null
    }
}

export default ()=> Session.getInstance();