import { h, forceUpdate } from 'preact';
import { Consumer } from '../../utils'
//import { Link } from 'preact-router/match';

const Header = (props, ctx) => {
	console.log(ctx.data)
	return (
		<header className='header'>
			<div className="container">
				<h1>Login</h1>
				{ctx.data && (<div id="hamburger-button" className={`hamburger ${props.menu.visible && 'hamburger-active'}`}
					onClick={() => props.menu.toggle()}>
					<hr />
					<hr />
					<hr />
				</div>)}
			</div>
		</header>
	);
}



export default Header;
