import ObservableData from './ObservableData'
import Provider from './Provider'
import Consumer from './Consumer'

let instance = null;
function AppData() {
    if(instance===null){
        console.log("New AppData created")
        const root = new ObservableData();
        root.get("affe1234/123");
        instance = {
            data: root.data,
            get: root.get,
            Provider: Provider.bind(this),
            Consumer: Consumer.bind(this),
        }
    }

    return instance;
}

export default AppData;